jQuery( document ).ready( function( $ ) {
	'use strict';

/* Add New page
------------------------------------------------------------------- */
	$( 'input#requires_confirmation' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-returnurl' ).slideDown();
			$( '#dk-speakout input#return_url' ).focus();
		} else {
			$( 'div.dk-speakout-returnurl' ).slideUp();
		}
	});

	// open or close signature goal settings
	$( 'input#has_goal' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-goal' ).slideDown();
			$( '#dk-speakout input#goal' ).focus();
		} else {
			$( 'div.dk-speakout-goal' ).slideUp();
		}
	});
	
	// open or close redirect url settings
	$( 'input#redirect_url_option' ).change( function () {
	   if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-redirection-url' ).slideDown();
			$( '#dk-speakout input#redirect_url' ).focus();
		} else {
			$( 'div.dk-redirection-url' ).slideUp();
		}
	});

	// open or close expiration date settings
	$( 'input#expires' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-date' ).slideDown();
		} else {
			$( 'div.dk-speakout-date' ).slideUp();
		}
	});

	// open or close address fields settings
	$( 'input#display-address' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-address' ).slideDown();
			$( 'div.dk_speakout_address_required' ).slideDown();
		} else {
			$( 'div.dk-speakout-address' ).slideUp();
			$( 'div.dk_speakout_address_required' ).slideUp();
		}
	});

	// open or close custom field settings
	$( 'input#displays-custom-field' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-custom-field' ).slideDown();
			$( '#dk-speakout input#custom-field-label' ).focus();
		} else {
			$( 'div.dk-speakout-custom-field' ).slideUp();
		}
	});
	
	// open or close custom message settings
	$( 'input#displays-custom-message' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-custom-message' ).slideDown();
			$( '#dk-speakout input#custom-message-label' ).focus();
		} else {
			$( 'div.dk-speakout-custom-message' ).slideUp();
		}
	});

	// open or close email opt-in settings
	$( 'input#displays-optin' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-optin' ).slideDown();
			$( '#dk-speakout input#optin-label' ).focus();
		} else {
			$( 'div.dk-speakout-optin' ).slideUp();
		}
	});

	// if hide_email_field is checked in db
	if ( $( 'input#hide_email_field' ).prop( 'checked' ) ) {
        $( '#displays-optin' ).attr( "disabled", true );
        $( '#displays-optin-label' ).css( 'color', 'grey' );
        $( 'input#hide_email_field' ).attr( "disabled", true );
        $( 'input#sends_email' ).attr( "disabled", true );
        $( 'input#requires_confirmation' ).attr( "disabled", true );
        $( '#requires_confirmation-label' ).css( 'color', 'grey' );
	}

	// if changing hide_email_address do some things
	$( 'input#hide_email_field' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'input#displays-optin' ).attr( "disabled", true );
			$( 'input#displays-optin' ).prop( "checked", false );
			$( '#displays-optin' ).attr("disabled", true );
			$( '#displays-optin-label' ).css( 'color', 'grey' );
			$( 'div.dk-speakout-optin' ).slideUp();
			$( 'input#requires_confirmation' ).attr( "disabled", true );
            $( '#requires_confirmation-label' ).css( 'color', 'grey' );
            $( '.hide_email_warning' ).css( 'color', 'red' );
			
		} else {
			$( '#displays-optin' ).attr( "disabled", false );
			$( '#displays-optin-label' ).css( 'color', 'black' );
			$( 'input#requires_confirmation' ).attr( "disabled", false );
            $( '#requires_confirmation-label' ).css( 'color', 'black' );
             $( '.hide_email_warning' ).css( 'color', 'black' );
		}
	});
	
	// open or close email header settings on start
	if ( $( 'input#sends_email' ).prop( 'checked' ) ) {
		$( 'div.dk-speakout-email-headers' ).hide();
		$( 'div.dk-speakout-hide-email-option' ).show();
		
	}
	
	$( 'input#sends_email' ).change( function () {
		if ( $( this ).prop( 'checked' ) ) {
			$( 'div.dk-speakout-email-headers' ).slideUp();
			$( 'div.dk-speakout-hide-email-option' ).slideDown();
			
		} else {
			$( 'div.dk-speakout-email-headers' ).slideDown();
			$( 'div.dk-speakout-hide-email-option' ).slideUp();
			$( '#hide_email_field' ).prop('checked', false);
		}
	}); 

	// auto-focus the title field on add/edit petitions form if empty
	if ( $( '#dk-speakout input#title' ).val() === '' ) {
		$( '#dk-speakout input#title' ).focus();
	}

	// validate form values before submitting
	$( '#dk_speakout_submit' ).click( function() {

		$( '.dk-speakout-error' ).removeClass( 'dk-speakout-error' );

		var errors     = 0,
			emailRegEx = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,6})?$/,
			email      = $( '#dk-speakout-edit-petition #target_email' ).val(),
			emailCC    = $( '#dk-speakout-edit-petition #target_email_CC' ).val(),
			subject    = $( '#dk-speakout-edit-petition #email_subject' ).val(),
			message    = $( '#dk-speakout-edit-petition #petition_message' ).val(),
			customlabel = $( '#dk-speakout-edit-petition #custom-field-label' ).val(),
			//messagedisplay = $( '#dk-speakout-edit-petition input#display_petition_message' ).prop(),
			goal       = $( '#dk-speakout-edit-petition #goal' ).val(),
			day        = $( '#dk-speakout-edit-petition #day' ).val(),
			year       = $( '#dk-speakout-edit-petition #year' ).val(),
			hour       = $( '#dk-speakout-edit-petition #hour' ).val(),
			minutes    = $( '#dk-speakout-edit-petition #minutes' ).val(),
			delay       = Math.floor($( '#dk-speakout-edit-petition #redirect_delay' ).val());

		// if "Do not send email (only collect signatures)" checkbox is not checked
		if ( !$( 'input#sends_email' ).prop( 'checked' ) ) {
			// remove any spaces
			var emails = email.split( ',' );
			for ( var i=0; i < emails.length; i++ ) {
				if ( emails[i].trim() === '' || !emailRegEx.test( emails[i].trim() ) ) { // must include valid email address
					$( '#dk-speakout-edit-petition #target_email' ).addClass( 'dk-speakout-error' );
					errors ++;
				}
			}
			
			if ( subject === '' ) { // must include subject
				$( '#dk-speakout-edit-petition #email_subject' ).addClass( 'dk-speakout-error' );
				errors ++;
			}
		}
		// remove any spaces
			var emailsCC = emailCC.split( ',' );
			for ( var x=0; x < emailsCC.length; x++ ) {
				if (emailsCC[x].trim() !== '' && !emailRegEx.test( emailsCC[x].trim() ) ) { // If email address included it must be valid
					$( '#dk-speakout-edit-petition #target_email_CC' ).addClass( 'dk-speakout-error' );
					errors ++;
				}
			}

		// must include petition message if message is being displayed
		if ( message === '' && $( 'input#display_petition_message' ).prop( 'checked' ) ) { 	
			$( '#dk-speakout-edit-petition #petition_message' ).addClass( 'dk-speakout-error' );
			errors ++;
		}

		// must include custom field label if using custom field
		if ( $( 'input#displays-custom-field' ).prop( 'checked' )  && customlabel === "") { 
			$( '#dk-speakout-edit-petition #custom-field-label' ).addClass( 'dk-speakout-error' );
			errors ++;
		}
		
		// if "Set signature goal" checkbox is checked
		if ( $( 'input#has_goal' ).prop( 'checked' ) ) {
			if ( isNaN( goal ) ) { // only numbers are allowed
				$( '#dk-speakout-edit-petition #goal' ).addClass( 'dk-speakout-error' );
				errors ++;
			}
		}

		// if "Set expiration date" checkbox is checked
		if ( $( 'input#expires' ).prop( 'checked' ) ) {
			if ( isNaN( day ) ) { // only numbers are allowed
				$( '#dk-speakout-edit-petition #day' ).addClass( 'dk-speakout-error' );
				errors ++;
			}
			if ( isNaN( year ) ) { // only numbers are allowed
				$( '#dk-speakout-edit-petition #year' ).addClass( 'dk-speakout-error' );
				errors ++;
			}
			if ( isNaN( hour ) ) { // only numbers are allowed
				$( '#dk-speakout-edit-petition #hour' ).addClass( 'dk-speakout-error' );
				errors ++;
			}
			if ( isNaN( minutes ) ) { // only numbers are allowed
				$( '#dk-speakout-edit-petition #minutes' ).addClass( 'dk-speakout-error' );
				errors ++;
			}

		}
			if( isNaN(delay)){
			    $( '#dk-speakout-edit-petition #redirect_delay' ).addClass( 'dk-speakout-error' );
				errors ++;
			}
		// if no errors found, submit the form
		if ( errors === 0 ) {

			// uncheck all address fields if "Display address fields" is not checked
			if ( ! $( 'input#display-address' ).prop( 'checked' ) ) {
				$( '#street' ).removeAttr( 'checked' );
				$( '#city' ).removeAttr( 'checked' );
				$( '#state' ).removeAttr( 'checked' );
				$( '#postcode' ).removeAttr( 'checked' );
				$( '#country' ).removeAttr( 'checked' );
				$( '#address-required' ).removeAttr( 'checked' );
			}

			$( 'form#dk-speakout-edit-petition' ).submit();
		}
		else {
			$( '.dk-speakout-error-msg' ).fadeIn();
		}

		return false;

	});

	// display character count for for Twitter Message field
	// max characters is 260 to accomodate the shortnened URL provided by Twitter when submitted
	function dkSpeakoutTwitterCount() {
		var max_characters = 260;
		var text = $( '#twitter_message' ).val();
		var charcter_count = text.length;
		var charcters_left = max_characters - charcter_count;

		if ( charcter_count <= max_characters ) {
			$( '#twitter-counter' ).html( charcters_left ).css( 'color', '#000' );
		}
		else {
			$( '#twitter-counter' ).html( charcters_left ).css( 'color', '#c00' );
		}
	}
	if ( $( '#twitter_message' ).length > 0 ) {
		dkSpeakoutTwitterCount();
	}
	$( '#twitter_message' ).keyup( function() {
		dkSpeakoutTwitterCount();
	});

/* Petitions page
------------------------------------------------------------------- */
	// display confirmation box when user tries to delete a petition
	// warns that all signatures associated with the petition will also be deleted
	$( '.dk-speakout-delete-petition' ).click( function( e ) {
		e.preventDefault();

		var delete_link = $( this ).attr( 'href' );
		// confirmation message is contained in a hidden div in the HTML
		// so that it is accessible to PHP translation methods
		var confirm_message = $( '#dk-speakout-delete-confirmation' ).html();
		// add new line characters for nicer confirm msg display
		confirm_message = confirm_message.replace( '? ', '?\n\n' );
		// display confirmation box
		var confirm_delete = confirm( confirm_message );
		// if user presses OK, process delete link
		if ( confirm_delete === true ) {
			document.location = delete_link;
		}
	});

/* Signatures page
------------------------------------------------------------------- */
	// Select box navigation on Signatures page
	// to switch between different petitions
	$('#dk-speakout-switch-petition').change( function() {
		var page    = 'dk_speakout_signatures',
			action  = 'petition',
			pid     = $('#dk-speakout-switch-petition option:selected').val(),
			baseurl = String( document.location ).split( '?' ),
			newurl  = baseurl[0] + '?page=' + page + '&action=' + action + '&pid=' + pid;
		document.location = newurl;
	});
    
    // select all signatures
    $("#dk-speakout-signatures-checkAll").click(function(){
        $('input:checkbox').not(this).prop('checked', this.checked);
    });
    
    //get a list of checked signatures
    var siglist;
    var sigcount;
    function getSiglist(){
        siglist = "";
        sigcount = 0;
        $('.dk-speakout-signaturecheck:checked').each(function() {
            siglist = siglist + $(this).val() + "|";
            sigcount++
        });
    }

	// Bulk action on Signatures page
	$('#dk-speakout-bulk-action-form').submit( function() {
    
        //get the petition ID
        var pid     = $('#dk-speakout-switch-petition option:selected').val();
        
        // action based on selection
        switch ($('#dk-speakout-bulk-action-form option:selected').val()){
    		case "csv-download":
    		    var page    = 'dk_speakout_signatures',
    			baseurl = String( document.location ).split( '?' ),
    			newurl  = baseurl[0] + '?page=' + page + '&pid=' + pid + '&csv=signatures&_wpnonce=' + $('#csvnonce').val();
    		document.location = newurl;
    		return false;

    		case "display-unconfirmed":
        		    var link = window.location.href +"&action=displayunconfirmed&pid=" + pid + "&_wpnonce=" + $('#confnonce').val();
        	        document.location = link;
    		 return false;
    		 
    		case "confirm-resend":
        		// confirmation message is contained in a hidden div in the HTML
        		// so that it is accessible to PHP translation methods
        		var confirm_message = $( '#dk-speakout-reconfirm-confirmation' ).html();
        		// add new line characters for nicer confirm msg display
        		confirm_message = confirm_message.replace( '? ', '?\n\n' );
        		// display confirm box
        		var confirm_delete = confirm( confirm_message );
        		// if user presses OK, process delete link
        		
        		if ( confirm_delete === true ) {
        		    var link = window.location.href +"&action=reconfirm&pid=" + pid + "&_wpnonce=" + $('#confnonce').val();
        	        document.location = link;
    		    }
    		 return false;
     
         	case "reconfirm-selected":
         		getSiglist();
        		// confirmation message is contained in a hidden div in the HTML
        		// so that it is accessible to PHP translation methods
        		var confirm_message = $( '#dk-speakout-reconfirm-selected-confirmation' ).html();
        		// add new line characters for nicer confirm msg display
        		confirm_message = confirm_message.replace( '? ', '?\n\n' );
        		// display confirm box
        		var confirm_delete = confirm( confirm_message );
        		// if user presses OK, process delete link
        		
        		if ( confirm_delete === true ) {
        		    var link = window.location.href +"&action=reconfirmselected&pid=" + pid + "&_wpnonce=" + $('#confnonce').val() + "&siglist=" + siglist;
        	        document.location = link;
    		    }
    		 return false;
     
     
         	case "forceconfirm-selected":
         	    getSiglist();
                
        		// confirmation message is contained in a hidden div in the HTML
        		// so that it is accessible to PHP translation methods
        		confirm_message = $( '#dk-speakout-forceconfirm-confirmation-open' ).html() + sigcount + $( '#dk-speakout-confirmation-close' ).html();
        		//handle plurals
        		confirm_message = (confirm_message > 1) ? confirm_message + "s." : confirm_message + "."; 
        		
        		// add new line characters for nicer confirm msg display
        		confirm_message = confirm_message.replace( '? ', '?\n\n' );
        		// display confirm box
        		var confirm_force = confirm( confirm_message );
        		
        		// if user presses OK, process link
            	if ( confirm_force === true ) {
            	    $.ajax({
                        url: window.location.href,
                        data: "&action=forceconfirm" + "&_wpnonce=" + $('#confnonce').val() + "&pid=" + pid + "&siglist=" + siglist,
                        success: function(response) {
                            document.location = window.location.href
                        }
                    });
    		    }
    		 return false;  
    		 
            case "delete-selected":
         	    getSiglist();
                
        		// confirmation message is contained in a hidden div in the HTML
        		// so that it is accessible to PHP translation methods
        		confirm_message = $( '#dk-speakout-delete-confirmation-open' ).html() + sigcount + $( '#dk-speakout-confirmation-close' ).html();
        		//handle plurals
        		confirm_message = (confirm_message > 1) ? confirm_message + "s." : confirm_message + "."; 
        		
        		// add new line characters for nicer confirm msg display
        		confirm_message = confirm_message.replace( '? ', '?\n\n' );
        		// display confirm box
        		confirm_delete = confirm( confirm_message );

        		// if user presses OK, process link
            	if ( confirm_delete === true ) {
            	    $.ajax({
                        url: window.location.href,
                        data: "&action=deleteselected" + "&_wpnonce=" + $('#confnonce').val() + "&pid=" + pid + "&siglist=" + siglist,
                        success: function(response) {
                            document.location = window.location.href
                        }
                    });
    		    }
    		return false;  
        }
        
	});


    // change options text based on checkboxes
    $("#dk-speakout-signaturelist").contents().find(":checkbox").on('change', function(){ 
        // if we don't have any signatures selected
        if($("#dk-speakout-signaturelist input:checkbox:checked").length === 0){
            $("#dk-speakout-action-selector option[value='delete-selected']").prop("disabled", true);
            $("#dk-speakout-action-selector option[value='reconfirm-selected']").prop("disabled", true);
            $("#dk-speakout-action-selector option[value='reconfirm-selected']").text( $("#dk-speakout-reconfirm-unselected-text").val() );
            $("#dk-speakout-action-selector option[value='forceconfirm-selected']").prop("disabled", true);
            $("#dk-speakout-action-selector option[value='forceconfirm-selected']").text( $("#dk-speakout-confirm-unselected-text").val() );   
            $("#dk-speakout-action-selector option[value='delete-selected']").prop("disabled", true);
            $("#dk-speakout-action-selector option[value='delete-selected']").text( $("#dk-speakout-delete-unselected-text").val() ); 
            //if no petition or signatures disable the button
            if( $('#dk-speakout-switch-petition option:selected').val() === ""){
                $("#dk-speakout-doaction").prop("disabled", true);
            }
        }
        else{ // if we do have signatures selected
            // but we don't have a petition selected
            if( $('#dk-speakout-switch-petition option:selected').val() === ""){
                $("#dk-speakout-action-selector option[value='reconfirm-selected']").text( $("#dk-speakout-reconfirm-selected-no-petition-text").val() );
                $("#dk-speakout-action-selector option[value='forceconfirm-selected']").text( $("#dk-speakout-force-confirm-selected-no-petition-text").val() );
            }
            else{ // or we do have petition selected
                $("#dk-speakout-action-selector option[value='reconfirm-selected']").removeAttr('disabled'); 
                $("#dk-speakout-action-selector option[value='reconfirm-selected']").text( $("#dk-speakout-reconfirm-selected-text").val() );
                $("#dk-speakout-action-selector option[value='forceconfirm-selected']").removeAttr('disabled'); 
                $("#dk-speakout-action-selector option[value='forceconfirm-selected']").text( $("#dk-speakout-force-confirm-selected-text").val() );
            }
            $("#dk-speakout-doaction").removeAttr('disabled');
            $("#dk-speakout-action-selector option[value='delete-selected']").removeAttr('disabled'); 
            $("#dk-speakout-action-selector option[value='delete-selected']").text( $("#dk-speakout-delete-selected-text").val() );
        }
    });
    
	// display confirmation box when user tries to re-send confirmation emails
	// warns that a bunch of emails will be sent out if they hit OK
	$( 'a#dk-speakout-reconfirm' ).click( function( e ) {
		e.preventDefault();

		var link = $( this ).attr( 'href' );
		// confirmation message is contained in a hidden div in the HTML
		// so that it is accessible to PHP translation methods
		var confirm_message = $( '#dk-speakout-reconfirm-confirmation' ).html();
		// add new line characters for nicer confirm msg display
		confirm_message = confirm_message.replace( '? ', '?\n\n' );
		// display confirm box
		var confirm_delete = confirm( confirm_message );
		// if user presses OK, process delete link
		if ( confirm_delete === true ) {
			document.location = link;
		}
	});

	// stripe the table rows
	$( 'tr.dk-speakout-tablerow:even' ).addClass( 'dk-speakout-tablerow-even' );

/* Pagination for Signatures and Petitions pages
------------------------------------------------------------------- */
	// when new page number is entered using the form on paginated admin pages,
	// construct a new url string to pass along the variables needed to update page
	// and redirect to the new url
	$( '#dk-speakout-pager' ).submit( function() {
		var page        = $( '#dk-speakout-page' ).val(),
			paged       = $( '#dk-speakout-paged' ).val(),
			total_pages = $( '#dk-speakout-total-pages' ).val(),
			baseurl     = String( document.location ).split( '?' ),
			newurl      = baseurl[0] + '?page=' + page + '&paged=' + paged + '&total_pages=' + total_pages;
		document.location = newurl;
		return false;
	});

/* Petition page
------------------------------------------------------------------- */
	// make the correct tab active on page load
	var addNewCcurrentTab = $( 'input#dk-petition-tab' ).val();
	$( '#' + addNewCcurrentTab ).show();
	$( 'ul#dk-petition-tabbar li a.' + addNewCcurrentTab ).addClass( 'dk-petition-active' );

	// switch tabs when they are clicked
	$( 'ul#dk-petition-tabbar li a' ).click( function( e ) {
		e.preventDefault();

		// tab bar display
		$( 'ul#dk-petition-tabbar li a' ).removeClass( 'dk-petition-active' );
		$( this ).addClass( 'dk-petition-active' );

		// content sections display
		$( '.dk-petition-tabcontent' ).hide();

		var newTab = $( this ).attr( 'rel' );
		$( 'input#dk-petition-tab' ).val( newTab );

		$( '#' + newTab ).show();
	});


/* Settings page
------------------------------------------------------------------- */
	// make the correct tab active on page load
	var currentTab = $( 'input#dk-speakout-tab' ).val();
	$( '#' + currentTab ).show();
	$( 'ul#dk-speakout-tabbar li a.' + currentTab ).addClass( 'dk-speakout-active' );

	// switch tabs when they are clicked
	$( 'ul#dk-speakout-tabbar li a' ).click( function( e ) {
		e.preventDefault();

		// tab bar display
		$( 'ul#dk-speakout-tabbar li a' ).removeClass( 'dk-speakout-active' );
		$( this ).addClass( 'dk-speakout-active' );

		// content sections display
		$( '.dk-speakout-tabcontent' ).hide();

		var newTab = $( this ).attr( 'rel' );
		$( 'input#dk-speakout-tab' ).val( newTab );

		$( '#' + newTab ).show();
	});

});